VERSION 4.00
Begin VB.Form NeuroXor 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "NeuroXor"
   ClientHeight    =   5280
   ClientLeft      =   8160
   ClientTop       =   1830
   ClientWidth     =   4950
   Height          =   5715
   Left            =   8085
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5280
   ScaleWidth      =   4950
   ShowInTaskbar   =   0   'False
   Top             =   1470
   Width           =   5100
   Begin VB.CommandButton AboutCommand 
      Caption         =   "About"
      Height          =   375
      Left            =   4080
      TabIndex        =   17
      Top             =   4200
      Width           =   735
   End
   Begin VB.CommandButton LoadCommand 
      Caption         =   "Load"
      Height          =   375
      Left            =   4080
      TabIndex        =   16
      Top             =   3840
      Width           =   735
   End
   Begin VB.CommandButton SaveCommand 
      Caption         =   "Save"
      Height          =   375
      Left            =   4080
      TabIndex        =   15
      Top             =   3480
      Width           =   735
   End
   Begin VB.CommandButton BuildCommand 
      Caption         =   "BuildBPN"
      Height          =   375
      Left            =   3120
      TabIndex        =   14
      Top             =   3480
      Width           =   855
   End
   Begin VB.CommandButton TrainCommand 
      Caption         =   "Train"
      Height          =   375
      Left            =   1800
      TabIndex        =   13
      Top             =   3480
      Width           =   735
   End
   Begin VB.CommandButton RunCommand 
      Caption         =   "Run"
      Height          =   375
      Left            =   1800
      TabIndex        =   12
      Top             =   4560
      Width           =   735
   End
   Begin VB.TextBox Output 
      Height          =   285
      Left            =   3960
      TabIndex        =   11
      Top             =   4680
      Width           =   855
   End
   Begin VB.TextBox Input2 
      Height          =   285
      Left            =   720
      TabIndex        =   10
      Text            =   "1"
      Top             =   4800
      Width           =   855
   End
   Begin VB.TextBox Input1 
      Height          =   285
      Left            =   720
      TabIndex        =   9
      Text            =   "1"
      Top             =   4440
      Width           =   855
   End
   Begin VB.TextBox LoopEdit 
      Height          =   285
      Left            =   720
      TabIndex        =   8
      Text            =   "30"
      Top             =   3720
      Width           =   855
   End
   Begin VB.TextBox EpochEdit 
      Height          =   285
      Left            =   720
      TabIndex        =   7
      Text            =   "1000"
      Top             =   3360
      Width           =   855
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   735
      Left            =   720
      Picture         =   "NeuroXor.frx":0000
      ScaleHeight     =   705
      ScaleWidth      =   3345
      TabIndex        =   0
      Top             =   0
      Width           =   3375
   End
   Begin VB.Label Label6 
      Caption         =   "<-------"
      Height          =   255
      Left            =   2640
      TabIndex        =   18
      Top             =   3600
      Width           =   495
   End
   Begin VB.Label Label5 
      Caption         =   "------OUTPUT--->"
      Height          =   255
      Left            =   2640
      TabIndex        =   6
      Top             =   4680
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Input2"
      Height          =   255
      Left            =   0
      TabIndex        =   5
      Top             =   4800
      Width           =   495
   End
   Begin VB.Label Label3 
      Caption         =   "Input1"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   4440
      Width           =   495
   End
   Begin VB.Label Label2 
      Caption         =   "Loop"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   3720
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Epoch"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   3360
      Width           =   615
   End
   Begin BPNOCXLib.BpnOCX XorBpn 
      Height          =   2415
      Left            =   0
      TabIndex        =   1
      Top             =   840
      Width           =   4935
      _Version        =   65536
      _ExtentX        =   8705
      _ExtentY        =   4260
      _StockProps     =   45
      OutputSize      =   1
   End
End
Attribute VB_Name = "NeuroXor"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub AboutCommand_Click()
XorBpn.AboutBox
End Sub

Private Sub BuildCommand_Click()
Dim insample(8) As Single
Dim outsample(4) As Single
Dim i As Integer
Dim j As Integer
insample(1) = 0: insample(2) = 0: outsample(1) = 0
insample(3) = 0: insample(4) = 1: outsample(2) = 1
insample(5) = 1: insample(6) = 0: outsample(3) = 1
insample(7) = 1: insample(8) = 1: outsample(4) = 0
XorBpn.AllocateSampleArray 4
For i = 1 To 8
 XorBpn.SetInputArrayAt i - 1, insample(i)
Next i
For j = 1 To 4
 XorBpn.SetOutputArrayAt j - 1, outsample(j)
Next j
XorBpn.BuildBPN
End Sub


Private Sub LoadCommand_Click()
XorBpn.Load "C:\NEURON_XOR.BPN"
End Sub

Private Sub RunCommand_Click()
 Dim out As Single
 XorBpn.SetRecallInputArray 0, Input1.Text
 XorBpn.SetRecallInputArray 1, Input2.Text
 XorBpn.RecallForVB
 out = XorBpn.RecallOutputArray(0)
 If out < 0.5 Then
  output.Text = 0
 End If
 If out >= 0.5 Then
  output.Text = 1
 End If
End Sub

Private Sub SaveCommand_Click()
Rem you may want to open file common dlg to get the filename
XorBpn.Save "c:\NEURO_XOR.BPN"
End Sub


Private Sub TrainCommand_Click()
 XorBpn.RunTrainer 4, EpochEdit.Text, LoopEdit.Text
End Sub


